################################################################
# դNTP client
#
#		WIN32API
################################################################
use Socket;
use Win32::API;

#### define the structure
Win32::API::Struct->typedef( SYSTEMTIME => qw{
    WORD wYear; 
    WORD wMonth; 
    WORD wDayOfWeek; 
    WORD wDay; 
    WORD wHour; 
    WORD wMinute; 
    WORD wSecond; 
    WORD wMilliseconds; 
});

Win32::API->Import('kernel32', 'LONG SetSystemTime(LPSYSTEMTIME lpsystemtime)');

my $pt = Win32::API::Struct->new('SYSTEMTIME');

my @buf;
################ socket process ################
my ($gosa,$host, $protocol, $him, $src, $port, $ipaddr, $res, $delta, $msg,$tmhead,$buf,$ntp,$TransmitTime);

$gosa = 25 + 9;			#ꤹ
$host = '';	#NTPФ

$protocol = "ntp";

socket(MsgBox, PF_INET, SOCK_DGRAM, getprotobyname("udp"))
    or die "socket: $!";
$him = sockaddr_in(scalar(getservbyname($protocol, "udp")),
		   inet_aton($host));

#### send message to NTP server
$msg = pack("N12", 0x0B000000);

my @msg_print =  unpack("B32 B32 B32 B32 B64 B64 B64 B64", $msg);

defined(send(MsgBox, $msg, 0, $him))
    or die "send : $!";

#### receive packet
defined($src = recv(MsgBox, $res, 1024, 0))
    or die "recv : $!";
($port, $ipaddr) = sockaddr_in($src);
$host = gethostbyaddr($ipaddr, AF_INET);

################ parse SNTP packet from NTP server ################
# reference: RFC2030

#1900ǯ110ȤŪʺñ̤ɽ

#NTPॹץեޥåȤϡ17ǯֻѤ³ƤΤǡ
#40ǯ˥ॹץեɤСեȤǤ⡢
#ȤƤȤǽ롣
#ӥå01ˤʤ1968ǯNTPॹפѤĤŤ뤳Ȥϡ
#ŬڤǤΤǡNTPॹפ֤ͭĹؤˡȤơ
#Τ褦ʵѤˡ롣
#⤷ӥå01ΤȤϡɸϡ1968-2036ϰϤˤꡢɸϡ
#ɸ1900ǯ1100ʬ0ä׻롣
#⤷ӥå00ΤȤϡ֤ϡ2036-2104ϰϤˤꡢ
#ɸϡɸ2036ǯ27628ʬ16 ׻롣
#դ٤Ȥϡбط׻Ȥ
#2000ǯǯǤʤȤդ뤳ȤǤ롣
#ޤäϷ׻ǤϹθʤȤȤˤդ٤Ǥ롣 

# PerlTime 1970 / 1 / 1 UTCÿǤΤǡ
# ʬͤФʤʤ 70ǯ + 17 = 25567
#
# 2036/2/7 06:28:16 Ȥʤ
# 66ǯ * 365 + 15 + 31 + 7
# 2085955200 + 21600 + 1680 + 16
#2085978496

@buf = unpack("B32 B32 B32 B32 B64 B64 B64 B64 B*", $res);
$tmhead = substr($buf[6],0,1);

@buf = unpack("N*" , $res);
$TransmitTime = $buf[10];

if ($tmhead == 1) {
	#bit01 ʤΤ 1968-2036ϰϤǤȴꤹ
	$ntp = $TransmitTime - 2_208_988_800; #70ǯ֤ÿ
}
else {
	$ntp = $TransmitTime + 2_085_978_496;
}

#print "                               \$TransmitTime: $TransmitTime\n";
$ntp = $ntp + $gosa;

print " NTP time:  ". scalar(localtime($ntp)) . "    \$ntp:  ". $ntp . "\n";
print "localtime:  ". scalar(localtime()) . "  time():  ". time() . "\n";

#print "Mill:$buf[11]\n";

&getdate($ntp);
$pt->{wYear} = $ml_year;
$pt->{wMonth} = $ml_mon;
$pt->{wDay} = $ml_mday;
$pt->{wHour} = $ml_hour;
$pt->{wMinute} = $ml_min;
$pt->{wSecond} = $ml_sec;
#$pt->{wMilliseconds} = $buf[11];

#WORD wMilliseconds; 
#WORD wDayOfWeek; 

$ret = SetSystemTime($pt);
print "$ret\n";
sub getdate {
	local($nowtime) = @_;
	#($ml_sec,$ml_min,$ml_hour,$ml_mday,$ml_mon,$ml_year,$ml_wday,$ml_yday,$ml_isdst);

	$ENV{'TZ'} = "JST-9";

	($ml_sec, $ml_min, $ml_hour, $ml_mday, $ml_mon, $ml_year, $ml_wday, $ml_yday, $ml_isdst) = gmtime($nowtime);
	$ml_year = $ml_year + 1900;
	$ml_mon += 1;

	#Date: Fri, 20 Sep 1996 11:12:16 +0300
}
